package com.fzm.common.entity.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

/**
 * @author tangtuo
 * @date 2021/12/9 14:35
 */
@Data
public class CopyrightDTO {

    @ApiModelProperty("主键")
    private Integer id;

    @ApiModelProperty(value = "nft哈希")
    private String nftHash;

    @ApiModelProperty(value = "nft名称")
    private String nftName;

    @ApiModelProperty(value = "作品名称")
    private String opusName;

    @ApiModelProperty(value = "作品类别id")
    private Integer opusCategoryId;

    @ApiModelProperty(value = "作品性质")
    private String opusProperty;

    @ApiModelProperty(value = "内容简介")
    private String contentSynopsis;

    @ApiModelProperty(value = "创作过程")
    private String createProcess;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    @ApiModelProperty(value = "作品完成日期 格式:yyyy-MM-dd")
    private Date opusCompleteDate;

    @ApiModelProperty(value = "作品完成省份")
    private String opusCompleteProvince;

    @ApiModelProperty(value = "作品完成城市")
    private String opusCompleteCity;


    @ApiModelProperty(value = "'发表状态  0-未发表  1-已发表")
    private Integer publishState;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    @ApiModelProperty(value = "首次发表日期 格式:yyyy-MM-dd")
    private Date firstPublishDate;

    @ApiModelProperty(value = "首次发表省份")
    private String firstPublishProvince;

    @ApiModelProperty(value = "首次发表城市")
    private String firstPublishCity;

    @ApiModelProperty(value = "权力取得方式")
    private String authorityAcquireMode;

    @ApiModelProperty(value = "权力取得证明材料的文件地址")
    private String authorityAcquireProve;

    @ApiModelProperty(value = "权力归属方式")
    private String authorityAscriptionMode;

    @ApiModelProperty(value = "权力归属证明材料的文件地址")
    private String authorityAscriptionProve;

    @ApiModelProperty(value = "作者列表")
    private List<Author> authors;

    @ApiModelProperty(value = "著作权人id列表")
    private List<Integer> ownerIds;

    @ApiModelProperty("文件列表")
    private List<File> files;

    @ApiModelProperty("权力id集合")
    private List<Integer> authorityIds;

    @ApiModelProperty("json串")
    private String content;

    @Data
    public static class Author {

        @ApiModelProperty(value = "作者姓名或名称")
        private String name;

        @ApiModelProperty(value = "署名类型  (本名 | 别名 | 匿名)")
        private String signType;

        @ApiModelProperty(value = "签名")
        private String sign;

    }


    @Data
    public static class File {

        @ApiModelProperty("附件名")
        private String fileName;

        @ApiModelProperty("附件路径")
        private String fileUrl;

        @ApiModelProperty("文件hash")
        private String fileHash;

        @ApiModelProperty("文件扩展名")
        private String fileSuffix;
    }

}
