/**
 * Copyright 2021 bejson.com
 */
package com.fzm.common.entity.dto;

import cn.hutool.core.date.DateUtil;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * Auto-generated: 2021-12-15 16:10:11
 *
 * @author bejson.com (i@bejson.com)
 * @website http://www.bejson.com/java2pojo/
 */
@Data
public class CopyrightRequest {

    private String app_id;
    private String charset = "utf-8";
    private String sign;
    private String sign_type;
    private String timestamp = DateUtil.format(new Date(), "yyyy-MM-dd HH:mm:ss");
    private String version = "1.0";
    private CopyrightDetail biz_content;

    @Data
    public static class CopyrightDetail {

        @ApiModelProperty(value = "")
        private String affilia_photo;

        @ApiModelProperty(value = "")
        private String agency_photo;

        @ApiModelProperty(value = "")
        private String author_photo;

        @ApiModelProperty(value = "")
        private List<Cooperator> cooperator;

        @ApiModelProperty(value = "")
        private String end_address;

        @ApiModelProperty(value = "")
        private String end_time;

        @ApiModelProperty(value = "")
        private String entrust_photo;

        @ApiModelProperty(value = "")
        private Integer gain_code;

        @ApiModelProperty(value = "")
        private String gain_desc;

        @ApiModelProperty(value = "")
        private String gain_name;

        @ApiModelProperty(value = "")
        private String gain_photo;

        @ApiModelProperty(value = "")
        private String geren_uname;

        @ApiModelProperty(value = "")
        private String geren_uxname;

        @ApiModelProperty(value = "")
        private String geren_uxname_type;

        @ApiModelProperty(value = "")
        private String geren_uxname_type_name;

        @ApiModelProperty(value = "")
        private Integer is_grade;

        @ApiModelProperty(value = "")
        private Integer nature_code;

        @ApiModelProperty(value = "")
        private String nature_desc;

        @ApiModelProperty(value = "")
        private String nature_name;

        @ApiModelProperty(value = "")
        private String other_photo;

        @ApiModelProperty(value = "")
        private List<CopyrightOwner> owner_list;

        @ApiModelProperty(value = "")
        private String publish_address;

        @ApiModelProperty(value = "")
        private int publish_status;

        @ApiModelProperty(value = "")
        private String publish_time;

        @ApiModelProperty(value = "")
        private int rights_affilia_code;

        @ApiModelProperty(value = "")
        private String rights_affilia_name;

        @ApiModelProperty(value = "")
        private String rights_desc;

        @ApiModelProperty(value = "")
        private String rights_guarantee_photo;

        @ApiModelProperty(value = "")
        private String works_create_desc;

        @ApiModelProperty(value = "")
        private String works_desc;

        @ApiModelProperty(value = "")
        private List<WorksFile> works_files;

        @ApiModelProperty(value = "")
        private String works_name;

        @ApiModelProperty(value = "")
        private String works_type_code;

        @ApiModelProperty(value = "")
        private String works_type_desc;

        @ApiModelProperty(value = "")
        private String works_type_name;

    }


    @Data
    public static class Cooperator {

        @ApiModelProperty(value = "")
        private String signature_type;

        @ApiModelProperty(value = "")
        private String signature_type_name;

        @ApiModelProperty(value = "")
        private String uname;

        @ApiModelProperty(value = "")
        private String uxname;
    }

    @Data
    public static class CopyrightOwner {

        @ApiModelProperty(value = "")
        private String address;

        @ApiModelProperty(value = "")
        private String back_photo;

        @ApiModelProperty(value = "")
        private String city;

        @ApiModelProperty(value = "")
        private String city_id;

        @ApiModelProperty(value = "")
        private String company_photo;

        @ApiModelProperty(value = "")
        private String document_code;

        @ApiModelProperty(value = "")
        private String document_image;

        @ApiModelProperty(value = "")
        private int document_type_code;

        @ApiModelProperty(value = "")
        private String document_type_name;

        @ApiModelProperty(value = "")
        private String front_photo;

        @ApiModelProperty(value = "")
        private String handheld_photo;

        @ApiModelProperty(value = "")
        private int is_forever;

        @ApiModelProperty(value = "")
        private String other_document_code;

        @ApiModelProperty(value = "")
        private String other_end_date;

        @ApiModelProperty(value = "")
        private String owner_name;

        @ApiModelProperty(value = "")
        private String owner_sign_name;

        @ApiModelProperty(value = "")
        private String owner_type_code;

        @ApiModelProperty(value = "")
        private String owner_type_name;

        @ApiModelProperty(value = "")
        private String prove_photo;

        @ApiModelProperty(value = "")
        private String province;

        @ApiModelProperty(value = "")
        private String province_id;

        @ApiModelProperty(value = "")
        private String valid_end_date;

        @ApiModelProperty(value = "")
        private String valid_start_date;
    }

    @Data
    public static class WorksFile {

        @ApiModelProperty(value = "")
        private String file;

        @ApiModelProperty(value = "")
        private String file_format;

        @ApiModelProperty(value = "")
        private String file_name;

        @ApiModelProperty(value = "")
        private String file_size;

        @ApiModelProperty(value = "")
        private String file_token;

        @ApiModelProperty(value = "")
        private String keywords;
    }
}